#!/bin/sh

# $Id: tests.sh,v 1.1 2003/08/19 01:17:14 gilles Exp gilles $

# $Log: tests.sh,v $
# Revision 1.1  2003/08/19 01:17:14  gilles
# Initial revision
#


#### Shell pragmas

exec 3>&2 # 
#set -x   # debug mode. See what is running
set -e    # exit on first failure

#### functions definitions

echo3() {
        #echo '#####################################################' >&3
        echo "$*" >&3
}

run_test() {
        echo3 "#### $test_count $1"
        $1
        if test x"$?" = x"0"; then
                echo "$1 passed"
        else
                echo "$1 failed" >&2
        fi
}

run_tests() {
        for t in $*; do
                test_count=`expr 1 + $test_count`
                run_test $t
                sleep 1
        done
}

#### Variable definitions

prog=pop2imap
test_count=0

##### The tests functions

perl_syntax() {
        perl -c ./${prog}
}


no_args() {
        ./${prog}
}


loulplume() {
./pop2imap --host1 loul  --user1 gilles         --passfile1 /var/tmp/secret \
           --host2 plume --user2 tata@est.belle --passfile2 /var/tmp/secret.tata

}

badpophost() {
! ./pop2imap --host1 nogoodhost --user1 tata@est.belle --passfile1 /var/tmp/secret.tata \
           --host2 plume --user2 tutu@est.belle --passfile2 /var/tmp/secret.tutu
}

connect_refused() {
! ./pop2imap --host1 plume --port1 109 --user1 tata@est.belle --passfile1 /var/tmp/secret.tata \
             --host2 plume --user2 tutu@est.belle --passfile2 /var/tmp/secret.tutu

}


dry_mode() {

 ./pop2imap --host1 plume --user1 tata@est.belle --passfile1 /var/tmp/secret.tata \
            --host2 plume --user2 tutu@est.belle --passfile2 /var/tmp/secret.tutu \
	    --dry

}


delete_opt() {

 ./pop2imap --host1 plume --user1 tata@est.belle --passfile1 /var/tmp/secret.tata \
            --host2 plume --user2 tutu@est.belle --passfile2 /var/tmp/secret.tutu \
	    --delete

}



# mandatory tests

run_tests perl_syntax 


# All tests

test $# -eq 0 && run_tests \
        no_args \
        loulplume \
        badpophost \
	connect_refused \
	dry_mode \
	delete_opt

# selective tests

test $# -gt 0 && run_tests $*

# If there, all is good

echo3 ALL $test_count TESTS SUCCESSFUL





